// Command-line tool for cheap Vernam encoding

#include <err.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/cheap-vernam.h>

int main(int argc, char **argv) {
	if (argc != 4)
		errx(EXIT_FAILURE, "Wrong invocation");

	SDL_Surface *surface = IMG_Load(argv[2]);
	if (!surface)
		errx(EXIT_FAILURE, "IMG_Load: %s", IMG_GetError());

	uint64_t seed;
	if (sizeof(uint64_t) == sizeof(long))
		seed = atol(argv[1]);
	else if (sizeof(uint64_t) == sizeof(long long))
		seed = atoll(argv[1]);

	if (SDL_cheap_vernam(seed, surface))
		errx(EXIT_FAILURE, "SDL_cheap_vernam: failed");

	if (SDL_SaveBMP(surface, argv[3]))
		errx(EXIT_FAILURE, "SDL_SaveBMP: %s", SDL_GetError());

	SDL_FreeSurface(surface);
	return EXIT_SUCCESS;
}
